*** ./nbase/nbase_misc.c.ORIG	Wed Dec 14 22:55:27 2011
--- ./nbase/nbase_misc.c	Wed Dec 14 22:56:34 2011
***************
*** 117,122 ****
--- 117,126 ----
  #define INET6_ADDRSTRLEN 46
  #endif
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  /* Returns the UNIX/Windows errno-equivalent.  Note that the Windows
     call is socket/networking specific.  The windows error number
     returned is like WSAMSGSIZE, but nbase.h includes #defines to
*** ./traceroute.cc.ORIG	Wed Dec 14 23:20:48 2011
--- ./traceroute.cc	Wed Dec 14 23:21:00 2011
***************
*** 145,150 ****
--- 145,154 ----
  #include <set>
  #include <vector>
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  extern NmapOps o;
  
  /* The highest TTL we go up to if the target itself doesn't respond. */
*** ./TargetGroup.cc.ORIG	Wed Dec 14 23:22:17 2011
--- ./TargetGroup.cc	Wed Dec 14 23:22:48 2011
***************
*** 92,97 ****
--- 92,98 ----
  
  /* $Id: TargetGroup.cc 21904 2011-01-21 00:04:16Z fyodor $ */
  
+ #include "dnet.h"
  #include "tcpip.h"
  #include "TargetGroup.h"
  #include "NmapOps.h"
*** ./ncat/ncat_main.c.ORIG	Thu Dec 15 22:56:31 2011
--- ./ncat/ncat_main.c	Thu Dec 15 22:57:24 2011
***************
*** 112,117 ****
--- 112,121 ----
  #include <openssl/err.h>
  #endif
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  static int ncat_connect_mode(void);
  static int ncat_listen_mode(void);
  
*** ./ncat/ncat_connect.c.ORIG	Thu Dec 15 22:57:58 2011
--- ./ncat/ncat_connect.c	Thu Dec 15 22:58:11 2011
***************
*** 110,115 ****
--- 110,119 ----
  #include <openssl/err.h>
  #endif
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  struct conn_state {
      nsock_iod sock_nsi;
      nsock_iod stdin_nsi;
*** ./ncat/ncat_listen.c.ORIG	Thu Dec 15 22:58:21 2011
--- ./ncat/ncat_listen.c	Thu Dec 15 22:58:32 2011
***************
*** 111,116 ****
--- 111,120 ----
  #include <openssl/err.h>
  #endif
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  /* read_fds is the clients we are accepting data from. broadcast_fds is the
     clients were are sending data to. broadcast_fds doesn't include the listening
     socket and stdin. Network clients are not added to read_fds when --send-only
*** ./ncat/ncat_proxy.c.ORIG	Thu Dec 15 22:58:47 2011
--- ./ncat/ncat_proxy.c	Thu Dec 15 22:59:01 2011
***************
*** 97,102 ****
--- 97,106 ----
  #include <unistd.h>
  #endif
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  #ifndef WIN32
  /* SIG_CHLD handler */
  static void proxyreaper(int signo)
*** ./ncat/util.c.ORIG	Thu Dec 15 22:59:09 2011
--- ./ncat/util.c	Thu Dec 15 22:59:19 2011
***************
*** 110,115 ****
--- 110,119 ----
  #include <unistd.h>
  #endif
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  /* safely add 2 size_t */
  size_t sadd(size_t l, size_t r)
  {
*** ./nping/nping.cc.ORIG	Thu Dec 15 23:24:44 2011
--- ./nping/nping.cc	Thu Dec 15 23:25:19 2011
***************
*** 88,93 ****
--- 88,94 ----
   *                                                                         *
   ***************************************************************************/
  
+ #include "dnet.h"
  #include "nping.h"
  #include "output.h"
  #include "NpingOps.h"
***************
*** 102,108 ****
  #include "EchoServer.h"
  #include "ProbeMode.h"
  #include "common.h"
- #include "dnet.h"
  #include "pcap.h"
  #include <signal.h>
  #include <time.h>
--- 103,108 ----
*** ./nping/EchoServer.cc.ORIG	Thu Dec 15 23:43:42 2011
--- ./nping/EchoServer.cc	Thu Dec 15 23:44:08 2011
***************
*** 98,103 ****
--- 98,107 ----
  #include "ProbeMode.h"
  #include <signal.h>
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  extern NpingOps o;
  extern EchoServer es;
    
*** ./nping/ProbeMode.cc.ORIG	Thu Dec 15 23:45:15 2011
--- ./nping/ProbeMode.cc	Thu Dec 15 23:45:30 2011
***************
*** 95,100 ****
--- 95,104 ----
  #include "NpingOps.h"
  #include "IPv4Header.h"
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  extern NpingOps o;
  
  
*** ./nsock/src/nsock_core.c.ORIG	Tue May 29 23:34:52 2012
--- ./nsock/src/nsock_core.c	Tue May 29 23:35:24 2012
***************
*** 85,90 ****
--- 85,93 ----
  #include "nsock_pcap.h"
  #endif
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
  
  /* Nsock time of day -- we update this at least once per nsock_loop round (and
   * after most calls that are likely to block).  Other nsock files should grab
*** ./nsock/src/nsock_write.c.ORIG	Tue May 29 23:35:50 2012
--- ./nsock/src/nsock_write.c	Tue May 29 23:36:18 2012
***************
*** 62,67 ****
--- 62,71 ----
  #include <stdarg.h>
  #include <errno.h>
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  nsock_event_id nsock_sendto(nsock_pool ms_pool, nsock_iod ms_iod, nsock_ev_handler handler, int timeout_msecs,
                              void *userdata, struct sockaddr *saddr, size_t sslen, unsigned short port, const char *data, int datalen) {
    mspool *nsp = (mspool *)ms_pool;
*** ./nping/utils_net.cc.ORIG	Wed May 30 00:15:05 2012
--- ./nping/utils_net.cc	Wed May 30 00:15:19 2012
***************
*** 101,106 ****
--- 101,110 ----
  #include "dnet.h"
  #include <vector>
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  extern NpingOps o;
  
  int atoIP(const char *hostname, struct in_addr *dst){
*** ./libnetutil/netutil.cc.ORIG	Tue May 29 23:37:32 2012
--- ./libnetutil/netutil.cc	Wed May 30 00:01:48 2012
***************
*** 119,125 ****
  
  /* Define CMSG_* symbols for Solaris 9 and earlier. See
     http://wiki.opencsw.org/porting-faq#toc10. */
! #if defined(__sun) || defined(__sun__)
  # ifndef CMSG_ALIGN
  #   ifdef __sun__
  #     define CMSG_ALIGN(len) _CMSG_DATA_ALIGN (len)
--- 119,125 ----
  
  /* Define CMSG_* symbols for Solaris 9 and earlier. See
     http://wiki.opencsw.org/porting-faq#toc10. */
! #if defined(__sun) || defined(__sun__) || (defined(_AIX51) && !defined(_AIX53))
  # ifndef CMSG_ALIGN
  #   ifdef __sun__
  #     define CMSG_ALIGN(len) _CMSG_DATA_ALIGN (len)
***************
*** 3648,3653 ****
--- 3652,3665 ----
  
    return 0;
  }
+ 
+ #if defined(_AIX) && !defined(_AIX61)
+ #define IPV6_HOPLIMIT           40   /* ancillary-only option */
+ #define IPV6_RTHDR              50   /* routing header option */
+ #define IPV6_HOPOPTS            52   /* Hop-by-Hop Header */
+ #define IPV6_DSTOPTS            54   /* Destination Opts Header after Rthdr
+                                         or when there is no Rthdr */
+ #endif
  
  static int exthdr_type_to_cmsg_type(uint8_t type) {
    switch (type) {
*** ./tcpip.cc.ORIG	Wed May 30 00:02:18 2012
--- ./tcpip.cc	Wed May 30 00:03:40 2012
***************
*** 132,138 ****
  
  static PacketCounter PktCt;
  
! 
  
  
  
--- 132,140 ----
  
  static PacketCounter PktCt;
  
! #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
! #define ss_family __ss_family
! #endif
  
  
  
*** ./osscan2.cc.ORIG	Wed May 30 00:04:17 2012
--- ./osscan2.cc	Wed May 30 00:04:41 2012
***************
*** 105,110 ****
--- 105,114 ----
  
  #include "struct_ip.h"
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  #include <list>
  
  using namespace std;
*** ./FPEngine.cc.ORIG	Wed May 30 00:05:00 2012
--- ./FPEngine.cc	Wed May 30 00:05:16 2012
***************
*** 103,108 ****
--- 103,111 ----
  #include "linear.h"
  extern NmapOps o;
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
  
  /******************************************************************************
   * Globals.                                                                   *
*** ./NmapOps.cc.ORIG	Wed May 30 00:09:24 2012
--- ./NmapOps.cc	Wed May 30 00:09:40 2012
***************
*** 101,106 ****
--- 101,110 ----
  #include "winfix.h"
  #endif
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  NmapOps o;
  
  NmapOps::NmapOps() {
*** ./Target.cc.ORIG	Wed May 30 00:09:53 2012
--- ./Target.cc	Wed May 30 00:10:04 2012
***************
*** 105,110 ****
--- 105,114 ----
  #include "utils.h"
  #include "nmap_error.h"
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  extern NmapOps o;
  
  Target::Target() {
*** ./portreasons.cc.ORIG	Wed May 30 00:10:21 2012
--- ./portreasons.cc	Wed May 30 00:10:33 2012
***************
*** 105,110 ****
--- 105,114 ----
  #endif
  #include <iostream>
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  extern NmapOps o;
  class PortList;
  
*** ./nse_dnet.cc.ORIG	Wed May 30 00:11:18 2012
--- ./nse_dnet.cc	Wed May 30 00:11:37 2012
***************
*** 17,22 ****
--- 17,26 ----
  #include "lualib.h"
  }
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  #include <assert.h>
  
  extern NmapOps o;
*** ./nse_nmaplib.cc.ORIG	Wed May 30 00:11:49 2012
--- ./nse_nmaplib.cc	Wed May 30 00:12:02 2012
***************
*** 25,30 ****
--- 25,34 ----
  #include "nse_nsock.h"
  #include "nse_dnet.h"
  
+ #if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+ #define ss_family __ss_family
+ #endif
+ 
  extern NmapOps o;
  
  static const char *NSE_PROTOCOL_OP[] = {"tcp", "udp", "sctp", NULL};

--- nse_nsock.cc.orig   2018-01-11 18:33:38 -0600
+++ nse_nsock.cc        2018-01-11 18:36:41 -0600
@@ -14,6 +14,10 @@
 #include "nse_utility.h"
 #include "nse_ssl_cert.h"

+#if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+#define ss_family __ss_family
+#endif
+
 #if HAVE_OPENSSL
 /* See the comments in service_scan.cc for the reason for _WINSOCKAPI_. */
 #  define _WINSOCKAPI_

--- nsock/src/nsock_connect.c.orig      2018-01-11 18:36:54 -0600
+++ nsock/src/nsock_connect.c   2018-01-11 18:38:04 -0600
@@ -64,6 +64,9 @@
 #include <errno.h>
 #include <string.h>

+#if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+#define ss_family __ss_family
+#endif

 static int mksock_bind_addr(struct npool *ms, struct niod *iod) {
   int rc;
--- libnetutil/netutil.cc.orig  2018-01-11 18:38:23 -0600
+++ libnetutil/netutil.cc       2018-01-11 18:41:26 -0600
@@ -137,6 +137,10 @@

 #include "nbase.h"

+#if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+#define ss_family __ss_family
+#endif
+
 #ifdef WIN32
 #include "mswin32/winclude.h"
 #else
--- output.cc.orig      2018-01-11 18:41:44 -0600
+++ output.cc   2018-01-11 18:42:54 -0600
@@ -159,6 +159,10 @@
 #include <list>
 #include <sstream>

+#if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+#define ss_family __ss_family
+#endif
+
 extern NmapOps o;
 static const char *logtypes[LOG_NUM_FILES] = LOG_NAMES;

--- scan_engine.cc.orig 2018-01-11 18:44:23 -0600
+++ scan_engine.cc      2018-01-11 18:46:00 -0600
@@ -159,6 +159,10 @@
 #include <list>
 #include <map>

+#if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+#define ss_family __ss_family
+#endif
+
 extern NmapOps o;
 #ifdef WIN32
 /* from libdnet's intf-win32.c */

--- portlist.cc.orig    2018-01-11 18:46:17 -0600
+++ portlist.cc 2018-01-11 18:46:51 -0600
@@ -139,6 +139,10 @@
 #include "tcpip.h"
 #include "libnetutil/netutil.h"

+#if (defined(_AIX51) || defined(_AIX52) || defined(_AIX53)) && !(defined(_AIX61))
+#define ss_family __ss_family
+#endif
+
 #if HAVE_STRINGS_H
 #include <strings.h>
 #endif /* HAVE_STRINGS_H */
